﻿using UnityEngine;

public class Depth2D : MonoBehaviour
{
    // STATIC

    private static float s_Scale = 2f;

    // Serializable fields

    [SerializeField]
    private float m_Offset = 0f;

    // MonoBehaviour's interface

    void LateUpdate()
    {
        Vector3 currentPosition = transform.position;
        float z = m_Offset + currentPosition.y * s_Scale;
        Vector3 newPosition = new Vector3(currentPosition.x, currentPosition.y, z);
        transform.position = newPosition;
    }

    // LOGIC

    public void SetOffset(float i_Offset)
    {
        m_Offset = i_Offset;
    }
}