﻿using UnityEngine;
using UnityEngine.SceneManagement;

using System.Collections;

public enum nameScene { Intro, Menu, Game}

public class gjBootstrap : MonoBehaviour
{
    // STATIC

    private static string s_IntroScene = "Intro";
    private static string s_MenuScene = "Menu";
    private static string s_GameScene = "Game";

    // Serializable fields

    [SerializeField]
    private nameScene m_Scena = nameScene.Intro;

    // MonoBehaviour's interface

    void Start()
    {
        StartCoroutine(Bootstrap());
    }

    // INTERNALS

    private IEnumerator Bootstrap()
    {
        CreateAudioListener();

        yield return null;

        LoadNextScene();
    }

    private void CreateAudioListener()
    {
        GameObject audioListenerGo = new GameObject("AudioListener");
        audioListenerGo.AddComponent<AudioListener>();
        DontDestroyOnLoad(audioListenerGo);
    }

    private void LoadNextScene()
    {
        switch (m_Scena)
        {
            case nameScene.Intro:
                LoadScena(s_IntroScene);
                break;

            case nameScene.Menu:
                LoadScena(s_MenuScene);
                break;

            case nameScene.Game:
                LoadScena(s_GameScene);
                break;
        }
    }

    private void LoadScena(string i_Scena)
    {
        SceneManager.LoadScene(i_Scena, LoadSceneMode.Single);
    }
}