﻿using UnityEngine;
using UnityEngine.UI;
using UnityEngine.SceneManagement;

using System;
using System.Collections;

[Serializable]
public class gjTutorialClipInfo
{
    [SerializeField]
    private Sprite m_Sprite = null;
    [SerializeField]
    private float m_Duration = 0f;

    public Sprite sprite
    {
        get
        {
            return m_Sprite;
        }
    }

    public float duration
    {
        get
        {
            return m_Duration;
        }
    }
}

public class gjTutorialManager : MonoBehaviour
{
    // STATIC

    private static string s_GameScene = "Game";

    // Serializable fields

    [SerializeField]
    private gjTutorialClipInfo[] m_Clips = null;
    [SerializeField]
    private Image m_Image = null; 

    // ACCESSORS

    public int clips
    {
        get
        {
            if (m_Clips != null)
            {
                return m_Clips.Length;
            }

            return 0;
        }
    }

    void Start()
    {
        StartCoroutine(Tutorial());
    }

    // Internals

    private IEnumerator Tutorial()
    {
        if (m_Clips != null)
        {
            for (int index = 0; index < m_Clips.Length; ++index)
            {
                gjTutorialClipInfo clip = m_Clips[index];

                if (clip == null)
                    continue;

                Sprite sprite = clip.sprite;

                if (m_Image != null)
                {
                    m_Image.sprite = sprite;
                }

                float duration = clip.duration;
                yield return new WaitForSeconds(duration);
            }
        }

        LoadGame(); 
    }

    private void LoadGame()
    {
        SceneManager.LoadScene(s_GameScene, LoadSceneMode.Single);
    }

}
